/****************************************************************************
*   Copyright (c) 1985,1991,1992 Digital Research Inc.			    *
*   All rights reserved.						    *
*   The Software Code contained in this listing is proprietary to Digital   *
*   Research Inc., Monterey, California, and is covered by U.S. and other   *
*   copyright protection.  Unauthorized copying, adaption, distribution,    *
*   use or display is prohibited and may be subject to civil and criminal   *
*   penalties.  Disclosure to others is prohibited.  For the terms and      *
*   conditions of software code use, refer to the appropriate Digital       *
*   Research License Agreement.						    *
*****************************************************************************
*		      U.S. GOVERNMENT RESTRICTED RIGHTS			    *
*                    ---------------------------------                      *
*  This software product is provided with RESTRICTED RIGHTS.  Use, 	    *
*  duplication or disclosure by the Government is subject to restrictions   *
*  as set forth in FAR 52.227-19 (c) (2) (June, 1987) when applicable or    *
*  the applicable provisions of the DOD FAR supplement 252.227-7013 	    *
*  subdivision (b)(3)(ii) (May 1981) or subdivision (c)(1)(ii) (May 1987).  *
*  Contractor/manufacturer is Digital Research Inc. / 70 Garden Court /     *
*  BOX DRI / Monterey, CA 93940.					    *
*****************************************************************************
* $Header: g:/groups/panther/dsk/rcs/deskbind.h 4.12 92/04/13 11:08:20 sbc Exp $
* $Log:	deskbind.h $
 * Revision 4.12  92/04/13  11:08:20  sbc
 * Add w_next member to WNODE. Keep track of g_whead and g_wavail ptrs.
 * 
 * Revision 4.11  92/04/10  13:40:27  sbc
 * Rm redundant preferences vars. Create new struct PREFS
 * 
 * Revision 4.10  92/04/09  14:54:11  sbc
 * Merge Becky's memory management improvements re backgrounds
 * 
 * Revision 4.9  92/04/03  17:08:10  sbc
 * Move externs from exobdefs.h to exproto.h
 * 
 * Revision 4.8  92/03/13  14:34:16  sbc
 * Replace refs to G.a_trees[ADMENU] with G.pMenuTree
 * 
 * Revision 4.7  92/03/13  09:44:51  sbc
 * rm code in ancient MULTIAPP compile switch.
 * 
 * Revision 4.6  92/03/12  13:54:13  rsf
 * Merge in RSF's changes for icons on desktop and (LONG) => (TREE).
 * 
 * Revision 4.5  92/02/19  15:56:34  sbc
 * remove NO_CLRICN_IMPL define (assume always on).
 * 
 * Revision 4.4  92/01/31  16:40:09  sbc
 * remove member a_wdta from structure GLOBES
 * 
 * Revision 4.3  92/01/28  15:00:54  rsf
 * *** empty log message ***
 * 
 * Revision 4.3  92/01/21  13:35:24  Fontes
 * Screen Saver and Background work merged w/ Jan 7 sources from Heather
 * 
 * Revision 4.2  92/01/06  13:19:38  anderson
 * Color icon work from Becky.
 * 
 * Revision 4.1  91/12/20  13:32:36  anderson
 * ViewMAX 3 baseline.  Converted TNODEs to FNODEs.  Also removed useless
 * second pointer into PNODE list.
 * 
 * Revision 3.1  91/08/19  16:31:19  system
 * ViewMAX 2 sources
 * 
*****************************************************************************/

#ifndef DESKBIND_INCLUDED
#define DESKBIND_INCLUDED

#define MAX_OBS 60

#define GLOBES struct glnode
GLOBES
{
	FNODE far *	g_flist;
	FNODE far *	g_favail;

	PNODE far	g_plist[NUM_PNODES];
	PNODE far *	g_pavail;

	WNODE far	g_wlist[(NUM_WNODES*2)];
	WNODE far *	g_wavail ;
	WNODE far *	g_whead ;

	ANODE		g_alist[NUM_ANODES];
	ANODE *		g_aavail;
	ANODE *		g_ahead;
	
	BYTE	g_wdta[128];

	WORD	g_index[NUM_WOBS];

	APPLBLK	g_udefs[NUM_WOBS];

	WORD	g_iwext;		/* w,h of extent of a	*/
	WORD	g_ihext;		/*   single item	*/
	WORD	g_iwint;		/* w,h of interval	*/
	WORD	g_ihint;		/*   between item	*/
	WORD	g_iwspc;		/* w,h of extent of a	*/
	WORD	g_ihspc;		/*   single iten	*/
	WORD	g_incol;		/* # of cols in full	*/
						/*   window		*/
	BYTE	g_srcpth[LEN_ZPATH];
	BYTE	g_dstpth[LEN_ZPATH];
				 		/* data xfer buffer and	*/
						/*   length for copying	*/
	BYTE far * g_xbuf;
	UWORD	g_xlen;
						/* stack of fcb's to use*/
						/*   for non-recursive	*/
						/*   directory tree	*/
						/*   traversal		*/
	FCB	g_fcbstk[MAX_LEVEL+1];
	LONG	g_nfiles;	/* Counts for all levels	*/
	LONG	g_ndirs;
	LONG	g_size;
	LONG	g_nfiles0;	/* Counts for current level	*/
	LONG	g_ndirs0;
	LONG	g_size0;

	BYTE	g_tmppth[90];

	WORD	g_xyobpts[MAX_OBS * 2];

	WORD	g_rmsg[8];

	WORD	g_xdesk;
	WORD	g_ydesk;
	WORD	g_wdesk;
	WORD	g_hdesk;

	WORD	g_xfull;
	WORD	g_yfull;
	WORD	g_wfull;
	WORD	g_hfull;

	BYTE	g_cmd[128];
	BYTE	g_tail[128];

	TREE	pMenuTree ;

	BYTE	g_croot;	/* current pseudo root	*/

	BYTE	g_cwin;			/* current window #	*/
	BYTE	g_wlastsel;		/* window holding last	*/
						/*   selection		*/
	BYTE	g_exec;		/* TRUE=terminate for exec */
	BYTE	g_1text[256];
	BYTE	g_2text[256];
	
	FDB far*g_bitmap;	/* curr. Bkgd bitmap	*/

	WORD	g_icw;
	WORD	g_ich;

	WORD	g_wicon;
	WORD	g_hicon;

	BYTE	*g_pbuff;
	BYTE	g_netname[12];
	BYTE	g_flpname[12];
	BYTE	g_hrdname[12];
	
	CICON	g_iconlist[NUM_IBLKS];

	OBJECT	g_screen[NUM_SOBS];		/* NUM_SOBS	*/

	WORD		num_tnodes;	/* Total number of tnodes	*/
	FNODE far	*t_drive[26];	/* Pointers to drive trees	*/
};

#endif /* ndef DESKBIND_INCLUDED */

/*
 *	EOF:	deskbind.h
 */
